/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { AnchoredRadialSeries } from "./AnchoredRadialSeries";
import { UnknownValuePlotting_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Array_$type, Point_$type, runOn, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ViewportUtils } from "./ViewportUtils";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-angular-core";
import { AnchoredRadialSeriesView } from "./AnchoredRadialSeriesView";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
var RadialAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialAreaSeries, _super);
    function RadialAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = RadialAreaSeries.$;
        return _this;
    }
    RadialAreaSeries.prototype.bk = function () {
        return new RadialAreaSeries();
    };
    RadialAreaSeries.prototype.get_ew = function () {
        return true;
    };
    RadialAreaSeries.prototype.ct = function () {
        return new RadialAreaSeriesView(this);
    };
    RadialAreaSeries.prototype.q7 = function (a) {
        _super.prototype.q7.call(this, a);
        this.adx = a;
    };
    RadialAreaSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    RadialAreaSeries.prototype.pb = function (a, b) {
        _super.prototype.pb.call(this, a, b);
        this.adx.dj();
    };
    RadialAreaSeries.prototype.abk = function (a, b) {
        _super.prototype.abk.call(this, a, b);
        var c = b.ca;
        var d = b.b9;
        var e = b.getEffectiveViewport();
        var f = b;
        if (b.r() && !c.isEmpty && !d.isEmpty && this.y9 != null && this.zf != null) {
            var g = a.h;
            var h = g.count;
            var i = new List$1(Array_$type, 2, h);
            var j = 0;
            for (var k = 0; k < h; k++) {
                var l = new Array(4);
                i.add(l);
                l[0] = this.zg.d(a.h._inner[k][0], a.h._inner[k][1], c, d, e);
                l[1] = this.zg.e(a.h._inner[k][0], a.h._inner[k][1], c, d, e);
                l[2] = this.zg.d(a.h._inner[k][0], a.h._inner[k][2], c, d, e);
                var m = a.h._inner[k][2];
                l[3] = this.zg.e(a.h._inner[k][0], m, c, d, e);
                if (m > j) {
                    j = m;
                }
            }
            var n = ViewportUtils.e(0.5, c, d, e);
            var o = ViewportUtils.i(0.5, c, d, e);
            this.adw = { $type: Point_$type, x: n, y: o };
            var p = this.getEffectiveViewport1(f);
            this.zo.a2(this, this.z5(), runOn(this, this.yx), this.aae(b), this.aaf(b));
            var q = false;
            var r = this.zo.b;
            if (r != null) {
                q = true;
            }
            if (q) {
                var s = new ScalerParams(0, b.ca, b.b9, this.y9.df, p);
                this.add(g, -1, this.acg.count, this.y9, s, b.t);
            }
            var t = f.ds;
            var u = f.dt;
            var v = f.dq;
            var w = f.dr;
            this.zo.ad(t, true, false, true, true);
            this.zo.ad(u, true, false, true, true);
            this.zo.ad(v, false, true, false, false);
            this.zo.ad(w, false, true, false, false);
            f.dk(a.h.count, i, false, this.adx.da.b, this.ie, runOn(this, this.ade), this.ady);
            v._opacity = this.zo.j * this.ia;
            w._opacity = 0.5 * this.zo.j * this.ia;
        }
    };
    RadialAreaSeries.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.qa(a, c, b);
        return c.toArray();
    };
    RadialAreaSeries.prototype.qa = function (a, b, c) {
        this.ada(a, b, c, this.za);
    };
    RadialAreaSeries.prototype.rg = function (a, b, c, d) {
        _super.prototype.rg.call(this, a, b, c, d);
        switch (b) {
            case RadialAreaSeries.$$p[0]:
                this.ry(false);
                this.qr();
                break;
        }
    };
    RadialAreaSeries.prototype.get_acm = function () {
        return true;
    };
    RadialAreaSeries.$t = markType(RadialAreaSeries, 'RadialAreaSeries', AnchoredRadialSeries.$);
    RadialAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialAreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting:ady:ad0', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return RadialAreaSeries;
}(AnchoredRadialSeries));
export { RadialAreaSeries };
/**
 * @hidden
 */
var RadialAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialAreaSeriesView, _super);
    function RadialAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.di = null;
        _this.dq = new Path();
        _this.ds = new Path();
        _this.dr = new Path();
        _this.dt = new Path();
        _this.dl = new Path();
        _this.dn = new Path();
        _this.dm = new Path();
        _this.dp = new Path();
        _this.di = a;
        return _this;
    }
    RadialAreaSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
            this.di.xk = Defaults.e;
        }
    };
    RadialAreaSeriesView.prototype.dj = function () {
        this.dq.an = null;
        this.ds.an = null;
        this.dr.an = null;
        this.dt.an = null;
        this.dl.an = null;
        this.dn.an = null;
        this.dm.an = null;
        this.dp.an = null;
        this.a2();
    };
    RadialAreaSeriesView.prototype.dk = function (a, b, c, d, e, f, g) {
        this.de.acb.i(this.dq, this.ds, this.dr, this.dt, a, b, c, d, e, f, g);
        this.a2();
    };
    RadialAreaSeriesView.prototype.bp = function () {
        _super.prototype.bp.call(this);
    };
    RadialAreaSeriesView.prototype.bq = function () {
        _super.prototype.bq.call(this);
        var a = this.b3();
        this.dn.an = this.ds.an;
        this.dp.an = this.dt.an;
        this.dl.an = this.dq.an;
        this.dm.an = this.dr.an;
        this.dn._stroke = a;
        this.dn.ad = this.f.ig + 3;
        this.dp._stroke = a;
        this.dp.ad = this.f.ig + 3;
        this.dl._fill = a;
        this.dl._opacity = 1;
        this.dm._fill = a;
        this.dm._opacity = 1;
    };
    RadialAreaSeriesView.prototype.bj = function (a, b) {
        _super.prototype.bj.call(this, a, b);
        if (a.d) {
            if (b) {
                a.t(this.dl);
                a.t(this.dm);
                a.t(this.dn);
                a.t(this.dp);
            }
            else {
                a.t(this.dq);
                a.t(this.dr);
                a.t(this.ds);
                a.t(this.dt);
            }
        }
    };
    RadialAreaSeriesView.prototype.ax = function (a) {
        _super.prototype.ax.call(this, a);
        this.f.bc.exportPathData(a, this.ds, "lowerShape", ["Lower"]);
        this.f.bc.exportPathData(a, this.dt, "upperShape", ["Upper", "Main"]);
        this.f.bc.exportPathData(a, this.dr, "translucentShape", ["Translucent"]);
        this.f.bc.exportPathData(a, this.dq, "fillShape", ["Fill"]);
    };
    RadialAreaSeriesView.$t = markType(RadialAreaSeriesView, 'RadialAreaSeriesView', AnchoredRadialSeriesView.$);
    return RadialAreaSeriesView;
}(AnchoredRadialSeriesView));
export { RadialAreaSeriesView };
